## coco-cs 20050504-1

=== debian/changelog ===
coco-cs (20050504-1) unstable; urgency=low

  * New Upstream release
  * Small bug in DFA fixed (EOF was not recognized correctly if ANY was used).
  * Coco/R as well as the generated compilers are reentrant now.
    That means that all fields and methods are non-static.
    Please look at the user manual to see how to create and
    initialize a scanner and a parser object in your compiler.
  * In addition to bracket comments (/* ... */), ATG files can also contain
    end of line comments now (// ... cr lf)
  * Corrected some package troubles.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Tue, 04 May 2005 16:00:00 +0100

coco-cs (20050316-2) unstable; urgency=low

  * debian/control: For Depends, mono-mcs
  * debian/control: For Build-Depends, unzip, mono-mcs (Closes: #302440)

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Fri, 01 Apr 2005 11:00:00 +0100

coco-cs (20050316-1) unstable; urgency=low

  * Scanners can read arbitrariliy large files now (needed for parsing 
    log files with several hundred megabytes).
  * Generated scanners are substantially faster than before (about 30%).

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Fri, 18 Mar 2005 13:00:00 +0100

coco-cs (20050111-1) unstable; urgency=low

  * First upload to Debian unstable.
    Sponsor: Rene Mayrhofer <rmayr@debian.org>
  * Renamed package to coco-cs.
  * Lexical structures like '(' {char} ')' resulted in an endless loop in the
    scanner if char was defined as ANY - ')' and if the terminating ')' was
    missing in the input stream of the generated compiler.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Tue, 11 Jan 2005 17:40:00 +0100

cocosorucescs (2004.10.27-2) unstable; urgency=low

  * Minor bug fixes in package.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at> Wed, 27 Oct 2004 18:40:00 +0100

cocosorucescs (2004.10.27-1) unstable; urgency=low

  * If an expression in curly braces or square brackets is deletable
    (as in [[x]]) a new LL(1) warning is printed: contents of [...]
    or {...}  must not be deletable.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at> Wed, 27 Oct 2004 17:15:00 +0100

cocosorucescs (2004.10.11-1) unstable; urgency=low

  * Blanks are specified as white spaces in the scanner frame now,
    so one can delete this if one doesn't want to ignore blanks.
    (Caution! Use the latest Coco.exe only with the latest Scanner.frame!)

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at> Tue, 11 Oct 2004 09:06:00 +0100

cocosorucescs (2004.06.28-3) unstable; urgency=low

  * Bug fix in ParserGen.cs and DFA.cs: Path seperator changed from "\\" to
    Path.DirectorySeperatorChar

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at> Tue, 24 Aug 2004 12:15:00 +0100

cocosorucescs (2004.06.28-2) unstable; urgency=low

  * Bug fix in Coco.atg: invalid TokenFactor and Terms caused Coco to crash.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at> Tue, 27 Jul 2004 09:00:00 +0100

cocosourcescs (2004.06.28-1) unstable; urgency=low

  * New upstream release
  * Generation of case-insensitive compilers changed
    - keyword IGNORECASE instead of IGNORE CASE.
    - case is also ignored in tokens and character sets now.
    - User manual changed
  * The scanner uses '\u0100' instead of '\u0' as an end of file (eof)
    character now. This allowes \0 to be used in tokens (useful for parsing
    binary files).
  * Bug fix in the detection of tokens that cannot be distinguished.
  * Various cleanups.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Tue,  06 Jul 2004 16:00:00 +0100

cocosourcescs (2004.04.14-1) unstable; urgency=low
 
  * Method Tab.IgnoreCase added
  * The frames directory is not specified by the environment variable CRFRAMES
    any more but can be specified with the command line option -frames
  * Bug fix in Coco.cs (incorrect handling of command line arguments)
  * Fatal errors abort with System.Environment.Exit(1)
    instead of System.Environment.Exit(0) now

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Fri,  16 Apr 2004 13:00:00 +0100

cocosourcescs (2004.04.06-4) unstable; urgency=low

  * corrected changelog  
  * directory names to lower case

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Tue,  13 Apr 2004 09:54:00 +0100

cocosourcescs (2004.04.06-3) unstable; urgency=low

  * Minor change: Error message changed form obsolete to misplaced resolver  

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Wed,  07 Apr 2004 19:00:00 +0100

cocosourcescs (2004.04.06-2) unstable; urgency=low

  * Documentation separated to cocosourcesdoc 

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Wed,  07 Apr 2004 19:00:00 +0100

cocosourcescs (2004.04.06-1) unstable; urgency=low

  * Resolvers have sometimes to be ignored in the computation of symbol sets
    and sometimes not. The way how it was done sofar has subtle errors.
    Changes in Tab.cs:
      - field ignoreRslvs removed
      - method Expected0 added
      - method Expected0 called twice in CheckAlts and once in CheckRes
      - CheckRes: computation of all start symbols of 
        an alternative chain modified
  * UserManual.pdf updated
  * Package name changed to lower case

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Thu,  06 Apr 2004 11:03:00 +0100

CocoSourcesCS (2004.04.01-2) unstable; urgency=low

  * Environment variable crframes changed to CRFRAMES

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Thu,  06 Apr 2004 11:03:00 +0100

CocoSourcesCS (2004.04.01-1) unstable; urgency=low

  * Characters in range 128..255 are handled correctly now. So far they were
    translated to '?'.
  * Corrected some directory names.
  * Package renamed to CocoSourcesCS, the 's' was missing.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Thu,  01 Apr 2004 08:03:00 +0100

CocoSourceCS (2004.01.07-1) unstable; urgency=low

  * New upstream release

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Thu,  12 Feb 2004 16:49:40 +0100

## coco-cs 20070906-3

=== Makefile ===
all:
	gmcs /out:Coco.exe /t:exe Coco.cs Scanner.cs Tab.cs DFA.cs ParserGen.cs Parser.cs 

clean:
	rm Coco.exe

install:
	install -m 0755 cococs $(DESTDIR)/usr/bin
	install -m 0755 Coco.exe $(DESTDIR)/usr/share/coco-cs
	install -m 0644 *frame $(DESTDIR)/usr/share/coco-cs

## coco-cs 20051117-1

=== debian/changelog ===
coco-cs (20051117-1) unstable; urgency=low

  * The if else if cascade of an alternative does not get optimized to a
    switch statement anymore if the alternative contains a LL(1) warning,
    thus coco generates at least compileable code in such a situation.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Thu, 17 Nov 2005 17:00:00 +0100

coco-cs (20050926-1) unstable; urgency=low

  * Constant declarations are generated for pragma names in the parser now
    (in case you want to access those names in semantic actions).

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Mon, 27 Sep 2005 19:23:00 +0100

coco-cs (20050919-1) unstable; urgency=low

  * Bug fixed in Tab.cs. Coco reported a misplaced resolver if 2 alternatives
    at the end of a production were deletable and a resolver was placed
    in front of the first one.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Mon, 19 Sep 2005 15:00:00 +0100

=== debian/control ===
Source: coco-cs
Section: devel
Priority: optional
Maintainer: Loeberbauer Markus <loeberbauer@ssw.jku.at>
Standards-Version: 3.6.1
Build-Depends: debhelper (>= 4.0.0), unzip, mono-mcs

Package: coco-cs
Architecture: all
Depends: mono, mono-mcs
Description: Coco/R Compiler Generator (C-Sharp Version)
 Coco/R is a compiler generator, which takes an attributed grammar of a source
 language and generates a scanner and a parser for this language. The scanner
 works as a deterministic finite automaton. The parser uses recursive descent.
 LL(1) conflicts can be resolved by a multi-symbol lookahead or by semantic
 checks. Thus the class of accepted grammars is LL(k) for an arbitrary k.
 .
 To start Coco call cococs, which is a shell script in /usr/bin.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1




BUILD_DIR = $(CURDIR)/debian/tmp-build/
CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	mkdir $(BUILD_DIR)
	( cd $(BUILD_DIR); \
	  unzip $(CURDIR)/CocoSourcesCS.zip; \
	  ln -s $(CURDIR)/*.sh . )

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	( cd $(BUILD_DIR); \
	  ./build.sh )

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	rm -rf $(BUILD_DIR)

	dh_clean 

install: DESTDIR=$(CURDIR)/debian/coco-cs
install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/coco-cs.
	install -m 0755 cococs $(DESTDIR)/usr/bin
	install -m 0755 $(BUILD_DIR)/Coco.exe $(DESTDIR)/usr/lib/coco-cs
	install -m 0644 $(BUILD_DIR)/*.cs $(DESTDIR)/usr/lib/coco-cs
	install -m 0644 $(BUILD_DIR)/*.atg $(DESTDIR)/usr/lib/coco-cs
	install -m 0644 $(BUILD_DIR)/*.frame $(DESTDIR)/usr/lib/coco-cs
	install -m 0755 $(CURDIR)/*.sh $(DESTDIR)/usr/lib/coco-cs

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman debian/cococs.1
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep
.PHONY: build clean binary-indep binary install configure

## coco-cs 20060919-2

=== debian/changelog ===
coco-cs (20060919-2) unstable; urgency=low

  * Update to Debian Policy Standards Version 3.7.2
  * Set MONO_SHARED_DIR to temporary directory to enable the build
    servers to build the package (Closes: #393811).

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Wed, 18 Oct 2006 18:00:00 +0100

coco-cs (20060919-1) unstable; urgency=low

  * Misplaced resolvers cause warnings instead of errros now.
  * The scanners generated by Coco/R can now also process Unicode characters
    in UTF-8 format. This implies that Coco/R itself supports UTF-8 now.
  * Attributes may now also contain the characters '<' and '>'
    (e.g. for operators or generic types). Such attributes must be
    enclosed in <. and .> brackets.
  * Error messages are written to an error stream instead of to the console.
    The error stream can be changed by the user.
  * The scanner now also recognizes the Unicode byte order mark for UTF-8.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Tue, 19 Sep 2006 16:00:00 +0100

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: devel
 Priority: optional
 Maintainer: Loeberbauer Markus <loeberbauer@ssw.jku.at>
-Standards-Version: 3.6.1
-Build-Depends: debhelper (>= 4.0.0), unzip, mono-mcs
+Standards-Version: 3.7.2
+Build-Depends: debhelper (>= 4.0.0), unzip, mono-gmcs
 
 Package: coco-cs
 Architecture: all
-Depends: mono, mono-mcs
+Depends: mono, mono-gmcs
 Description: Coco/R Compiler Generator (C-Sharp Version)
  Coco/R is a compiler generator, which takes an attributed grammar of a source
  language and generates a scanner and a parser for this language. The scanner

=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,7 @@
 
 
 BUILD_DIR = $(CURDIR)/debian/tmp-build/
+export MONO_SHARED_DIR = $(CURDIR)/debian/mono/
 CFLAGS = -Wall -g
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
@@ -39,8 +40,10 @@
 	dh_testdir
 
 	# Add here commands to compile the package.
-	( cd $(BUILD_DIR); \
-	  ./build.sh )
+	( mkdir $(MONO_SHARED_DIR); \
+	  cd $(BUILD_DIR); \
+	  ./build.sh; \
+	  rm -rf $(MONO_SHARED_DIR) )
 
 	touch build-stamp

## coco-cs 20070906-3

=== debian/changelog ===
coco-cs (20070906-3) unstable; urgency=low

  * Depend on mono-gmcs instead of mono (Closes: #457790).

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Thu, 27 Dec 2007 15:00:00 +0100

coco-cs (20070906-2) unstable; urgency=low

  * Minor Bugfix: Allow buffer position to be set to the end of the file,
    this allows grammars without trailing new-line.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Thu, 10 Sep 2007 15:00:00 +0100

coco-cs (20070906-1) unstable; urgency=low

  * The main method returns 1 if the grammar contained an error.
  * The possibility to set the output path with command line option "-o".
  * Enhanced support for input streams: Previously we did support seek-able
    streams with fixed size (e.g. files), but not non seek-able streams (e.g.
    network). Now we support both stream types. Please note since our memory
    buffer keeps the entire history of a non seek-able stream, the maximum
    supported stream size is limited by the available memory and the runtime
    environment.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Thu, 06 Sep 2007 14:45:00 +0100

coco-cs (20061206-1) unstable; urgency=low

  * The declaration of standard whitespaces (namely space) is again done in
    the file Scanner.frame.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Wed, 06 Dec 2006 14:45:00 +0100

coco-cs (20060919-3) unstable; urgency=low

  * Added binary-arch target in debian/rules (Closes: #395585).
  * It's now a non native package.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Fri, 10 Nov 2006 11:39:00 +0100

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Priority: optional
 Maintainer: Loeberbauer Markus <loeberbauer@ssw.jku.at>
 Standards-Version: 3.7.2
-Build-Depends: debhelper (>= 4.0.0), unzip, mono-gmcs
+Build-Depends: debhelper (>= 5), mono-gmcs
 
 Package: coco-cs
 Architecture: all
-Depends: mono, mono-gmcs
+Depends: mono-gmcs
 Description: Coco/R Compiler Generator (C-Sharp Version)
  Coco/R is a compiler generator, which takes an attributed grammar of a source
  language and generates a scanner and a parser for this language. The scanner

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


export MONO_SHARED_DIR = $(CURDIR)/debian/mono/

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	touch configure-stamp

build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	( mkdir $(MONO_SHARED_DIR); \
	  $(MAKE); \
	  rm -rf $(MONO_SHARED_DIR); )
	#docbook-to-man debian/coco-cs.sgml > coco-cs.1

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/coco-cs.
	$(MAKE) install DESTDIR=$(CURDIR)/debian/coco-cs


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman debian/cococs.1
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## coco-cs 20110419

=== debian/changelog ===
coco-cs (20110419-6) unstable; urgency=medium

  * QA upload.
  * Convert to 3.0 source format. (Closes: #1007636)
  * Update debhelper-compat to level 10.

 -- Bastian Germann <bage@debian.org>  Sun, 06 Aug 2023 14:47:39 +0200

coco-cs (20110419-5.2) unstable; urgency=medium

  * Non maintainer upload by the Reproducible Builds team.
  * No source change upload to rebuild on buildd with .buildinfo files.

 -- Holger Levsen <holger@debian.org>  Fri, 08 Jan 2021 14:10:45 +0100

coco-cs (20110419-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rebuild for CLR 4.5 transition (Closes: #804660)

 -- Jo Shields <directhex@apebox.org>  Wed, 18 Nov 2015 12:32:33 +0000

coco-cs (20110419-5) unstable; urgency=low

  * Switched to CLR 4.0 (Closes: #656690)

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Sat, 21 Jan 2012 17:58:30 +0100

coco-cs (20110419-4) unstable; urgency=low

  * fixed startup shell script

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Mon, 07 Nov 2011 11:12:02 +0100

coco-cs (20110419-3) unstable; urgency=low

  * List library dependencies (Closes: #631840)
  * Switched to dmcs (Closes: #627527) 

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Thu, 30 Jun 2011 07:55:00 +0200

coco-cs (20110419-2) unstable; urgency=low

  * Using default csharp compiler for debian mono-csc instead
    of gmcs (Closes: #627527) 

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Wed, 25 May 2011 10:18:00 +0200

coco-cs (20110419-1) unstable; urgency=low

  * New upstream release
  * Frame files provided as command line argument take now precedence
    over frame files in the source directory of the attributed grammar.
  * The namespace can be set as a directive in the attributed
    grammar: $namespace=NamespaceName
    if the namespace is set in the attributed grammar and on the command
    line, the command line argument takes precedence.
  * New option checkEOF: With the option checkEOF the user can specify
    whether the generated parser should check if the entire input has been
    consumed after parsing, i.e., if the token after the start symbol of
    the grammar is an end-of-file token. The user can enable or disable
    this check by the following directive in the attributed grammar:
    $checkEOF=true // enable the end of file check (default)
    $checkEOF=false // disable the end of file check
  * Support for UTF-8 input: The token stores the character position
    in Token.charPos.
  * Support for copyright sections in the generated files. If a
    file named Copyright.frame is provided, it will be included at
    the top of the generated scanner and parser.
  * Cleanup, removed the marker $$$ from the end of the frame files.
  * Minor Change: Unreachable nonterminals trigger warnings (have been
    errors), as it is in the Java version.
  * More robust scanner generation.
  * More robust UTF-8 handling in ParserGen.CopySourcePart and
    Scanner.GetString.
  * Simplified Coco.atg (using statements handled by ANY).
  * Minor change: Code cleanup.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Tue, 19 Apr 2011 15:52:02 +0200

coco-cs (20090327-1) unstable; urgency=low

  * New upstream release
  * Support for pragmas which are part of terminal classes (thanks
    to Serge Voloshenyuk)
  * Minor change: Code cleanup.
  * Adaptions to mono repackaging (Closes: #521909)

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Thu, 02 Apr 2009 10:00:00 +0100

coco-cs (20081108-1) unstable; urgency=low

  * New upstream release
  * Bugfix: bug in DFA.NumberNodes (introduced in 20081001).
  * Minor change: Code cleanup.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Mon, 10 Oct 2008 07:45:00 +0100

coco-cs (20081001-2) unstable; urgency=low

  * More robust clean target in make file.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Sat, 04 Oct 2008 10:00:00 +0100

coco-cs (20081001-1) unstable; urgency=low

  * New upstream release
  * Bugfix: bug in the construction of the scanner automaton fixed.
  * Minor change: More robust Peek method is Scanner.
  * Minor change: Allow underscores (_) in identifiers.

 -- Markus Loeberbauer <Loeberbauer@ssw.jku.at>  Tue, 23 Sep 2008 21:20:00 +0100

=== debian/control ===
Source: coco-cs
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 10), mono-devel (>= 2.10.5), cli-common-dev (>= 0.8.2~)
Standards-Version: 3.9.2
Homepage: http://www.ssw.uni-linz.ac.at/Research/Projects/Coco/

Package: coco-cs
Architecture: all
Depends: ${cli:Depends}, ${misc:Depends}
Description: Coco/R Compiler Generator (C-Sharp Version)
 Coco/R is a compiler generator, which takes an attributed grammar of a source
 language and generates a scanner and a parser for this language. The scanner
 works as a deterministic finite automaton. The parser uses recursive descent.
 LL(1) conflicts can be resolved by a multi-symbol lookahead or by semantic
 checks. Thus the class of accepted grammars is LL(k) for an arbitrary k.
 .
 To start Coco call cococs, which is a shell script in /usr/bin.

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,11 @@
 	# Add here commands to configure the package.
 	touch configure-stamp
 
-build: build-stamp
+build: build-arch build-indep
+
+build-arch: build-stamp
+
+build-indep: build-stamp
 
 build-stamp: configure-stamp 
 	dh_testdir
@@ -37,14 +41,14 @@
 	rm -f build-stamp configure-stamp
 
 	# Add here commands to clean up after the build process.
-	-$(MAKE) clean
+	$(MAKE) clean
 
 	dh_clean 
 
 install: build
 	dh_testdir
 	dh_testroot
-	dh_clean -k 
+	dh_prep
 	dh_installdirs
 
 	# Add here commands to install the package into debian/coco-cs.
@@ -53,10 +57,6 @@
 
 # Build architecture-independent files here.
 binary-indep: build install
-# We have nothing to do by default.
-
-# Build architecture-dependent files here.
-binary-arch: build install
 	dh_testdir
 	dh_testroot
 	dh_installchangelogs 
@@ -78,13 +78,48 @@
 	dh_strip
 	dh_compress
 	dh_fixperms
+	dh_clifixperms
 #	dh_perl
 #	dh_makeshlibs
+	dh_clistrip
+	dh_clideps
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol
 	dh_md5sums
 	dh_builddeb
 
+
+# Build architecture-dependent files here.
+#binary-arch: build install
+#	dh_testdir
+#	dh_testroot
+#	dh_installchangelogs 
+#	dh_installdocs
+#	dh_installexamples
+#	dh_install
+#	dh_installmenu
+#	dh_installdebconf	
+#	dh_installlogrotate
+#	dh_installemacsen
+#	dh_installpam
+#	dh_installmime
+#	dh_python
+#	dh_installinit
+#	dh_installcron
+#	dh_installinfo
+#	dh_installman debian/cococs.1
+#	dh_link
+#	dh_strip
+#	dh_compress
+#	dh_fixperms
+#	dh_perl
+#	dh_makeshlibs
+#	dh_installdeb
+#	dh_shlibdeps
+#	dh_gencontrol
+#	dh_md5sums
+#	dh_builddeb
+
 binary: binary-indep binary-arch
 .PHONY: build clean binary-indep binary-arch binary install configure
